﻿Type=Service
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
    #StartAtBoot: True
#End Region

Sub Process_Globals
End Sub

Sub Service_Create
End Sub

Sub Service_Start (StartingIntent As Intent)

	'maybe set last start "Time" to file / ketstore
	'Read on Service Start to determine last start time .. and set ScheduleNextServiceStart  accordingly.
	'rewrite new start time to file /keystore
	
	ToastMessageShow ("Starting Notif Service ...",False)
	'schedule next service regardless
	ScheduleNextServiceStart(16,46)

	' if starting intent was Not from reboot or Main activity it must have been from scheduled restart ..
	'show notification and stop service
	If StartingIntent.Action = "android.intent.action.BOOT_COMPLETED" OR _
		StartingIntent.Action = "Started_From_MAIN" Then		
	Else
		Dim n As Notification
    	n.Initialize
    	n.Icon = "icon"
    	n.SetInfo("Title", "Message", Main)				
		n.Notify(1) 		
	End If
	
	StopService("")		


End Sub

Sub ScheduleNextServiceStart(Hours As Int, Minutes As Int)
	
	'determine current day of week ..
	Dim DayofWeek As Int = DateTime.GetDayOfWeek(DateTime.Now)
	Dim DaysToRestart As Int
	
	Select Case DayofWeek ' depending on what day it is .. we calculate period to next run day ( wednesday or friday)
		Case 1	'sunday
			DaysToRestart = 3
		Case 2	'monday
			DaysToRestart = 2
		Case 3	'tuesday
			DaysToRestart = 1
		Case 4	'wednesday
			DaysToRestart = 2
		Case 5	'thursday
			DaysToRestart = 1
		Case 6	'friday
			DaysToRestart = 5
		Case 7	'saturday	
			DaysToRestart = 4
	End Select
	
	Dim Ticks, Today, NextRunTime As Long
	Ticks = Hours * DateTime.TicksPerHour + Minutes * DateTime.TicksPerMinute 
	Today = DateTime.DateParse(DateTime.Date(DateTime.Now))

    NextRunTime = Today + (DaysToRestart * DateTime.TicksPerDay) + Ticks

	StartServiceAt("",NextRunTime,True)
	
	DateTime.DateFormat = "EEEE  dd / MMM / yyyy"
	Log("NextRunTime : " & DateTime.Date(NextRunTime)  & " At " & DateTime.Time(NextRunTime) & " Hours")
	
End Sub
